package com.steerinfo.meterwork.meterworkscheduledhelp.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.metermonitor.metermonitornote.model.MeterMonitorNote;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcaractualfirst.model.MeterWorkCarActualFirst;
import com.steerinfo.meterwork.meterworkscheduledhelp.model.MeterWorkScheduledHelp;
import com.steerinfo.meterwork.meterworkscheduledhelp.service.IMeterWorkScheduledHelpService;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkScheduledHelp RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-28 11:46
 * 类描述
 * 修订历史：
 * 日期：2022-04-28
 * 作者：generator
 * 参考：
 * 描述：MeterWorkScheduledHelp RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkscheduledhelps")
public class MeterWorkScheduledHelpController extends BaseRESTfulController {

    @Autowired
    IMeterWorkScheduledHelpService meterWorkScheduledHelpService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @GetMapping(value = "/likeByDesc")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.likeByDesc(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="计量大厅-获取异常报警信息列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @PostMapping(value = "/HelpMsgByDesc")
    public RESTfulResult HelpMsgByDesc(@RequestBody HashMap parmas){
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.HelpMsgByDesc(parmas, Integer.parseInt(parmas.get("pageNum").toString()), Integer.parseInt(parmas.get("pageSize").toString()));
        return success(list);
    }

    @ApiOperation(value="各种报警信息汇总统计-获取列表", notes="不分页模糊查询")
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @PostMapping(value = "/helpContentSummary")
    public RESTfulResult helpContentSummary(@RequestBody(required = false) HashMap parmas){
        List<HashMap> list = meterWorkScheduledHelpService.helpContentSummary(parmas);
        return success(list);
    }

    @ApiOperation(value="各种报警信息明细-获取列表", notes="不分页模糊查询")
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @PostMapping(value = "/helpContentDetail")
    public RESTfulResult helpContentDetail(@RequestBody HashMap parmas){
        Integer pageNum = Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize = Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.helpContentDetail(parmas, pageNum, pageSize);
        return success(list);
    }


    @ApiOperation(value="创建", notes="根据MeterWorkScheduledHelp对象创建")
    @ApiImplicitParam(name = "meterWorkScheduledHelp", value = "详细实体meterWorkScheduledHelp", required = true, dataType = "MeterWorkScheduledHelp")
    //@RequiresPermissions("meterworkscheduledhelp:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkScheduledHelp model){
        RESTfulResult rm = failed();
        try {
            RESTfulResult res = meterWorkScheduledHelpService.checkAdd(model);
            return res;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkScheduledHelp meterWorkScheduledHelp = meterWorkScheduledHelpService.getById(id);
        return success(meterWorkScheduledHelp);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkScheduledHelp信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkScheduledHelp", value = "详细实体meterWorkScheduledHelp", required = true, dataType = "MeterWorkScheduledHelp")
    })
    //@RequiresPermissions("meterworkscheduledhelp:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkScheduledHelp model){
        model.setId(id);
        MeterWorkScheduledHelp meterWorkScheduledHelp = meterWorkScheduledHelpService.modify(model);
        return success(meterWorkScheduledHelp);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkscheduledhelp:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkScheduledHelpService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "智能终端报警信息", notes = "智能终端报警信息")
    @PostMapping(value = "/scheduledHelp")
    public RESTfulResult scheduledHelp(@RequestBody HashMap<String, Object> param) {
        RESTfulResult rm = failed();
        String carNo = param.get("carNo") == null ? "":param.get("carNo").toString();
        String baseSpotNo = param.get("baseSpotNo") == null ? "" : param.get("baseSpotNo").toString();
        String baseSpotName = param.get("baseSpotName") == null ? "" : param.get("baseSpotName").toString();
        String helpContent = param.get("helpContent") == null ? "" : param.get("helpContent").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(carNo)){
                rm.setMessage("车号不能为空，请确认！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(baseSpotNo)){
                rm.setMessage("计量站点编号不能为空，请确认！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(baseSpotName)){
                rm.setMessage("计量站点名称不能为空，请确认！！");
                return rm;
            }else if(StringUtils.isEmpty(helpContent)) {
                rm.setMessage("报警信息不能为空，请确认！！");
                return rm;
            }else {
                rm = meterWorkScheduledHelpService.scheduledHelp(carNo, baseSpotNo, baseSpotName, helpContent);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }

    @ApiOperation(value = "智能终端报警信息确认按钮", notes = "智能终端报警信息确认按钮")
    @PostMapping(value = "/scheduledHelpConfirm")
    public RESTfulResult scheduledHelpConfirm(@RequestBody HashMap params) {
        RESTfulResult rm = failed();
        String id = params.get("helpId") == null ? "": params.get("helpId").toString();
        String createNo = params.get("createNo") == null ? "" : params.get("createNo").toString();
        String createName = params.get("createName") == null ? "" : params.get("createName").toString();
        String result = params.get("result") == null ? "" : params.get("result").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(id)){
                rm.setMessage("远程求助ID不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createNo)){
                rm.setMessage("处理人编号不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createName)){
                rm.setMessage("处理人名称不能为空！！");
                return rm;
            }else{
                rm = meterWorkScheduledHelpService.scheduledHelpConfirm(id, createNo, createName, result);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkscheduledhelp:view")
    @GetMapping(value = "/allStateView/")
    public RESTfulResult allStateView(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkScheduledHelp> list = meterWorkScheduledHelpService.allStateView(parmas, pageNum, pageSize);
        return success(list);
    }
}
